diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/mainbus/wd.c sys/arch/arm32/mainbus/wd.c
*** sys/arch/arm32.orig/mainbus/wd.c	Wed Jun 12 22:41:10 1996
--- sys/arch/arm32/mainbus/wd.c	Thu Jun 13 03:11:10 1996
***************
*** 57,76 ****
  #include <machine/io.h>
  #include <machine/katelib.h>
  
- #include <arm32/mainbus/wdreg.h>
  #include <arm32/mainbus/mainbus.h>
! 
! extern int wdresethack;
! 
  #define	WAITTIME	(4 * hz)	/* time to wait for a completion */
- #define	RECOVERYTIME	(hz / 2)	/* time to recover from an error */
- 
- #define WDCDELAY	100
- #define WDCNDELAY	100000		/* delay = 100us; so 10s for a controller state change */
- #if 0
- /* If you enable this, it will report any delays more than 100us * N long. */
- #define WDCNDELAY_DEBUG	10
- #endif
  
  #define	WDIORETRIES	5		/* number of retries before giving up */
  
--- 57,67 ----
  #include <machine/io.h>
  #include <machine/katelib.h>
  
  #include <arm32/mainbus/mainbus.h>
! #include <arm32/mainbus/wdreg.h>
! #include <arm32/mainbus/wdlink.h>
!   
  #define	WAITTIME	(4 * hz)	/* time to wait for a completion */
  
  #define	WDIORETRIES	5		/* number of retries before giving up */
  
***************
*** 83,303 ****
  struct wd_softc {
  	struct device sc_dev;
  	struct disk sc_dk;
! 
! 	/* Information about the current transfer: */
! 	daddr_t sc_blkno;	/* starting block number */
! 	int sc_bcount;		/* byte count left */
! 	int sc_skip;		/* bytes already transferred */
! 	int sc_nblks;		/* number of blocks currently transferring */
! 	int sc_nbytes;		/* number of bytes currently transferring */
! 
! 	/* Long-term state: */
! 	int sc_drive;			/* physical unit number */
! 	int sc_state;			/* control state */
! #define	RECAL		0		/* recalibrate */
! #define	RECAL_WAIT	1		/* done recalibrating */
! #define	GEOMETRY	2		/* upload geometry */
! #define	GEOMETRY_WAIT	3		/* done uploading geometry */
! #define	MULTIMODE	4		/* set multiple mode */
! #define	MULTIMODE_WAIT	5		/* done setting multiple mode */
! #define	OPEN		6		/* done with open */
! 	int sc_mode;			/* transfer mode */
! #define	WDM_PIOSINGLE	0		/* single-sector PIO */
! #define	WDM_PIOMULTI	1		/* multi-sector PIO */
! #define	WDM_DMA		2		/* DMA */
! 	int sc_multiple;		/* multiple for WDM_PIOMULTI */
! 	int sc_flags;			/* drive characteistics found */
! #define	WDF_LOCKED	0x01
! #define	WDF_WANTED	0x02
! #define	WDF_WLABEL	0x04		/* label is writable */
! #define	WDF_LABELLING	0x08		/* writing label */
! /* XXX Nothing resets this yet, but disk change sensing will when ATAPI is
!    implemented. */
! #define	WDF_LOADED	0x10		/* parameters loaded */
! #define	WDF_32BIT	0x20		/* can do 32-bit transfer */
! 
! 	struct wdparams sc_params;	/* ESDI/ATA drive parameters */
! 	daddr_t	sc_badsect[127];	/* 126 plus trailing -1 marker */
! 
! 	TAILQ_ENTRY(wd_softc) sc_drivechain;
  	struct buf sc_q;
  };
  
! struct wdc_softc {
! 	struct device sc_dev;
! 	irqhandler_t sc_ih;
! 
! 	int sc_iobase;			/* I/O port base */
! 	int sc_drq;			/* DMA channel */
! 
! 	TAILQ_HEAD(drivehead, wd_softc) sc_drives;
! 	int sc_flags;
! #define	WDCF_ACTIVE	0x01		/* controller is active */
! #define	WDCF_SINGLE	0x02		/* sector at a time mode */
! #define	WDCF_ERROR	0x04		/* processing a disk error */
! #define	WDCF_WANTED	0x08		/* XXX locking for wd_get_parms() */
! 	int sc_errors;			/* errors during current transfer */
! 	u_char sc_status;		/* copy of status register */
! 	u_char sc_error;		/* copy of error register */
! };
! 
! int	wdcprobe 	__P((struct device *, void *, void *));
! void	wdcattach 	__P((struct device *, struct device *, void *));
! int	wdcintr		__P((void *));
! 
! struct cfattach wdc_ca = {
! 	sizeof(struct wdc_softc), wdcprobe, wdcattach
! };
  
! struct cfdriver wdc_cd = {
! 	NULL, "wdc", DV_DULL
  };
  
- int	wdprobe		__P((struct device *, void *, void *));
- void	wdattach	__P((struct device *, struct device *, void *));
- int	wdprint		__P((void *, char *));
- 
  struct cfattach wd_ca = {
  	sizeof(struct wd_softc), wdprobe, wdattach
  };
  
- struct cfdriver wd_cd = {
- 	NULL, "wd", DV_DISK
- };
  
! void	wdgetdisklabel	__P((struct wd_softc *));
! int	wd_get_parms	__P((struct wd_softc *));
! void	wdstrategy	__P((struct buf *));
! void	wdstart		__P((struct wd_softc *));
  
  struct dkdriver wddkdriver = { wdstrategy };
  
! /* XXX: these should go elsewhere */
! cdev_decl(wd);
! bdev_decl(wd);
! 
! void	wdfinish	__P((struct wd_softc *, struct buf *));
! int 	dcintr		__P((void *));
! void	wdcstart	__P((struct wdc_softc *));
! int	wdcommand	__P((struct wd_softc *, int, int, int, int, int));
! int	wdcommandshort	__P((struct wdc_softc *, int, int));
! int	wdcontrol	__P((struct wd_softc *));
! int	wdsetctlr	__P((struct wd_softc *));
! static void bad144intern __P((struct wd_softc *));
! int	wdcreset	__P((struct wdc_softc *));
! void	wdcrestart	__P((void *arg));
! void	wdcunwedge	__P((struct wdc_softc *));
! void	wdctimeout	__P((void *arg));
! void	wderror		__P((void *, struct buf *, char *));
! int	wdcwait		__P((struct wdc_softc *, int));
! int	wdlock		__P((struct wd_softc *));
! void	wdunlock	__P((struct wd_softc *));
! 
! /* ST506 spec says that if READY or SEEKCMPLT go off, then the read or write
!    command is aborted. */
! #define	wait_for_drq(d)		wdcwait(d, WDCS_DRDY | WDCS_DSC | WDCS_DRQ)
! #define	wait_for_ready(d)	wdcwait(d, WDCS_DRDY | WDCS_DSC)
! #define	wait_for_unbusy(d)	wdcwait(d, 0)
! 
! int
! wdcprobe(parent, match, aux)
! 	struct device *parent;
! 	void *match, *aux;
! {
! 	struct wdc_softc *wdc = match;
! 	struct mainbus_attach_args *mb = aux;
! 	int iobase;
! 
! 	wdc->sc_iobase = iobase = mb->mb_iobase;
! 
! 	/* Check if we have registers that work. */
! 	outb(iobase+wd_error, 0x5a);	/* Error register not writable, */
! 	outb(iobase+wd_cyl_lo, 0xa5);	/* but all of cyllo are. */
! 	if (inb(iobase+wd_error) == 0x5a || inb(iobase+wd_cyl_lo) != 0xa5)
! 		return 0;
! 
! 	if (wdcreset(wdc) != 0) {
! 		delay(500000);
! 		if (wdcreset(wdc) != 0)
! 			return 0;
! 	}
! 
! 	/* Select drive 0. */
! 	outb(iobase+wd_sdh, WDSD_IBM | 0);
! 
! 	/* Wait for controller to become ready. */
! 	if (wait_for_unbusy(wdc) < 0)
! 		return 0;
!     
! 	/* Start drive diagnostics. */
! 	outb(iobase+wd_command, WDCC_DIAGNOSE);
! 
! 	/* Wait for command to complete. */
! 	if (wait_for_unbusy(wdc) < 0)
! 		return 0;
! 
! 	mb->mb_iosize = 32;
! 	return 1;
! }
! 
! struct wdc_attach_args {
! 	int wa_drive;
! };
  
! int
! wdprint(aux, wdc)
! 	void *aux;
! 	char *wdc;
! {
! 	struct wdc_attach_args *wa = aux;
! 
! 	if (!wdc)
! 		printf(" drive %d", wa->wa_drive);
! 	return QUIET;
! }
! 
! void
! wdcattach(parent, self, aux)
! 	struct device *parent, *self;
! 	void *aux;
! {
! 	struct wdc_softc *wdc = (void *)self;
! 	struct mainbus_attach_args *mb = aux;
! 	struct wdc_attach_args wa;
! 
! 	TAILQ_INIT(&wdc->sc_drives);
! 	wdc->sc_drq = mb->mb_drq;
! 
! 	printf("\n");
! 
!   	wdc->sc_ih.ih_func = wdcintr;
!    	wdc->sc_ih.ih_arg = wdc;
!    	wdc->sc_ih.ih_level = IPL_BIO;
!    	wdc->sc_ih.ih_name = "wdc";
! 	if (irq_claim(mb->mb_irq, &wdc->sc_ih))
! 		panic("Cannot claim IRQ %d for wdc%d\n", mb->mb_irq, parent->dv_unit);
! 
! 	for (wa.wa_drive = 0; wa.wa_drive < 2; wa.wa_drive++)
! 		(void)config_found(self, (void *)&wa, wdprint);
! }
  
  int
  wdprobe(parent, match, aux)
  	struct device *parent;
  	void *match, *aux;
  {
! 	struct wdc_softc *wdc = (void *)parent;
  	struct cfdata *cf = match;
! 	struct wdc_attach_args *wa = aux;
! 	int drive = wa->wa_drive;
! 
! 	if (cf->cf_loc[0] != -1 && cf->cf_loc[0] != drive)
! 		return 0;
  	
! 	if (wdcommandshort(wdc, drive, WDCC_RECAL) != 0 ||
! 	    wait_for_ready(wdc) != 0)
  		return 0;
- 
  	return 1;
  }
  
--- 74,123 ----
  struct wd_softc {
  	struct device sc_dev;
  	struct disk sc_dk;
! 	struct wd_link *d_link;
  	struct buf sc_q;
  };
  
! int wdprobe	__P((struct device *, void *, void *));
! void wdattach	__P((struct device *, struct device *, void *));
  
! struct cfdriver wd_cd = {
! 	NULL, "wd", DV_DISK
  };
  
  struct cfattach wd_ca = {
  	sizeof(struct wd_softc), wdprobe, wdattach
  };
  
  
! void wdgetdisklabel __P((struct wd_softc *));
! void wdstrategy __P((struct buf *));
! void wdstart __P((struct wd_softc *));
  
  struct dkdriver wddkdriver = { wdstrategy };
  
! int wdlock __P((struct wd_link *));
! void wdunlock __P((struct wd_link *));
  
! int wdsetctlr __P((struct wd_link *));
! static void bad144intern __P((struct wd_softc *));
! int wdcdump __P((struct wd_link *, daddr_t blkno, int nblks, caddr_t va));
  
  int
  wdprobe(parent, match, aux)
  	struct device *parent;
  	void *match, *aux;
  {
! /*	caddr_t *wdc = (void *)parent;*/
  	struct cfdata *cf = match;
! 	struct wd_link *d_link = aux;
! 	int drive;
  	
! 	if (d_link == NULL ) return 0;
! 	if (d_link-> type != DRIVE) return 0;
! 	drive = d_link->sc_drive;
! 	if (cf->cf_loc[0] != -1 && cf->cf_loc[0] != drive)
  		return 0;
  	return 1;
  }
  
***************
*** 307,329 ****
  	void *aux;
  {
  	struct wd_softc *wd = (void *)self;
! 	struct wdc_softc *wdc = (void *)parent;
! 	struct wdc_attach_args *wa = aux;
  	int i, blank;
  	char buf[41], c, *p, *q;
  
! 	wd->sc_drive = wa->wa_drive;
  
! 	/*
! 	 * Initialize and attach the disk structure.
  	 */
  	wd->sc_dk.dk_driver = &wddkdriver;
  	wd->sc_dk.dk_name = wd->sc_dev.dv_xname;
  	disk_attach(&wd->sc_dk);
  
! 	wd_get_parms(wd);
! 	for (blank = 0, p = wd->sc_params.wdp_model, q = buf, i = 0;
! 	     i < sizeof(wd->sc_params.wdp_model); i++) {
  		c = *p++;
  		if (c == '\0')
  			break;
--- 127,153 ----
  	void *aux;
  {
  	struct wd_softc *wd = (void *)self;
! /*	struct caddr_t *wdc = (void *)parent;*/
! 	struct wd_link *d_link= aux;
  	int i, blank;
  	char buf[41], c, *p, *q;
  
! 	wd->d_link = d_link;
! 	d_link->openings = 1;
! 	d_link->wd_softc = (caddr_t)wd;
  
!  	/*
!     	 * Initialize and attach the disk structure.
  	 */
  	wd->sc_dk.dk_driver = &wddkdriver;
  	wd->sc_dk.dk_name = wd->sc_dev.dv_xname;
  	disk_attach(&wd->sc_dk);
  
! 	d_link->sc_lp = wd->sc_dk.dk_label;
! 
! 	wdc_get_parms(d_link);
! 	for (blank = 0, p = d_link->sc_params.wdp_model, q = buf, i = 0;
! 	     i < sizeof(d_link->sc_params.wdp_model); i++) {
  		c = *p++;
  		if (c == '\0')
  			break;
***************
*** 339,371 ****
  	*q++ = '\0';
  
  	printf(": %dMB, %d cyl, %d head, %d sec, %d bytes/sec <%s>\n",
! 	    wd->sc_params.wdp_cylinders *
! 	    (wd->sc_params.wdp_heads * wd->sc_params.wdp_sectors) /
  	    (1048576 / DEV_BSIZE),
! 	    wd->sc_params.wdp_cylinders,
! 	    wd->sc_params.wdp_heads,
! 	    wd->sc_params.wdp_sectors,
  	    DEV_BSIZE,
  	    buf);
  
! 	if ((wd->sc_params.wdp_capabilities & WD_CAP_DMA) != 0 &&
! 	    wdc->sc_drq != DRQUNK) {
! 		wd->sc_mode = WDM_DMA;
! 	} else if (wd->sc_params.wdp_maxmulti > 1) {
! 		wd->sc_mode = WDM_PIOMULTI;
! 		wd->sc_multiple = min(wd->sc_params.wdp_maxmulti, 16);
  	} else {
! 		wd->sc_mode = WDM_PIOSINGLE;
! 		wd->sc_multiple = 1;
  	}
  
  	printf("%s: using", wd->sc_dev.dv_xname);
! 	if (wd->sc_mode == WDM_DMA)
  		printf(" dma transfers,");
  	else
  		printf(" %d-sector %d-bit pio transfers,",
! 		    wd->sc_multiple, (wd->sc_flags & WDF_32BIT) == 0 ? 16 : 32);
! 	if ((wd->sc_params.wdp_capabilities & WD_CAP_LBA) != 0)
  		printf(" lba addressing\n");
  	else
  		printf(" chs addressing\n");
--- 163,195 ----
  	*q++ = '\0';
  
  	printf(": %dMB, %d cyl, %d head, %d sec, %d bytes/sec <%s>\n",
! 	    d_link->sc_params.wdp_cylinders *
! 	    (d_link->sc_params.wdp_heads * d_link->sc_params.wdp_sectors) /
  	    (1048576 / DEV_BSIZE),
! 	    d_link->sc_params.wdp_cylinders,
! 	    d_link->sc_params.wdp_heads,
! 	    d_link->sc_params.wdp_sectors,
  	    DEV_BSIZE,
  	    buf);
  
! 	if ((d_link->sc_params.wdp_capabilities & WD_CAP_DMA) != 0 &&
! 	    d_link->sc_mode == WDM_DMA) {
! 		d_link->sc_mode = WDM_DMA;
! 	} else if (d_link->sc_params.wdp_maxmulti > 1) {
! 		d_link->sc_mode = WDM_PIOMULTI;
! 		d_link->sc_multiple = min(d_link->sc_params.wdp_maxmulti, 16);
  	} else {
! 		d_link->sc_mode = WDM_PIOSINGLE;
! 		d_link->sc_multiple = 1;
  	}
  
  	printf("%s: using", wd->sc_dev.dv_xname);
! 	if (d_link->sc_mode == WDM_DMA)
  		printf(" dma transfers,");
  	else
  		printf(" %d-sector %d-bit pio transfers,",
! 		    d_link->sc_multiple, (d_link->sc_flags & WDF_32BIT) == 0 ? 16 : 32);
! 	if ((d_link->sc_params.wdp_capabilities & WD_CAP_LBA) != 0)
  		printf(" lba addressing\n");
  	else
  		printf(" chs addressing\n");
***************
*** 380,385 ****
--- 204,210 ----
  	struct buf *bp;
  {
  	struct wd_softc *wd = wd_cd.cd_devs[WDUNIT(bp->b_dev)];
+ 	struct wd_link *d_link= wd->d_link;
  	int s;
      
  	/* Valid request?  */
***************
*** 391,397 ****
  	}
      
  	/* If device invalidated (e.g. media change, door open), error. */
! 	if ((wd->sc_flags & WDF_LOADED) == 0) {
  		bp->b_error = EIO;
  		goto bad;
  	}
--- 216,222 ----
  	}
      
  	/* If device invalidated (e.g. media change, door open), error. */
! 	if ((d_link->sc_flags & WDF_LOADED) == 0) {
  		bp->b_error = EIO;
  		goto bad;
  	}
***************
*** 406,428 ****
  	 */
  	if (WDPART(bp->b_dev) != RAW_PART &&
  	    bounds_check_with_label(bp, wd->sc_dk.dk_label,
! 	    (wd->sc_flags & (WDF_WLABEL|WDF_LABELLING)) != 0) <= 0)
  		goto done;
      
  	/* Queue transfer on drive, activate drive and controller if idle. */
  	s = splbio();
  	disksort(&wd->sc_q, bp);
! 	if (!wd->sc_q.b_active)
! 		wdstart(wd);
! #if 0
! 	else {
! 		struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
! 		if ((wdc->sc_flags & (WDCF_ACTIVE|WDCF_ERROR)) == 0) {
! 			printf("wdstrategy: controller inactive\n");
! 			wdcstart(wdc);
! 		}
! 	}
! #endif
  	splx(s);
  	return;
      
--- 231,243 ----
  	 */
  	if (WDPART(bp->b_dev) != RAW_PART &&
  	    bounds_check_with_label(bp, wd->sc_dk.dk_label,
! 	    (d_link->sc_flags & (WDF_WLABEL|WDF_LABELLING)) != 0) <= 0)
  		goto done;
      
  	/* Queue transfer on drive, activate drive and controller if idle. */
  	s = splbio();
  	disksort(&wd->sc_q, bp);
! 	wdstart(wd);
  	splx(s);
  	return;
      
***************
*** 441,497 ****
  wdstart(wd)
  	struct wd_softc *wd;
  {
! 	struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
! 	int active = wdc->sc_drives.tqh_first != 0;
! 
! 	/* Link onto controller queue. */
! 	wd->sc_q.b_active = 1;
! 	TAILQ_INSERT_TAIL(&wdc->sc_drives, wd, sc_drivechain);
! 
! 	disk_busy(&wd->sc_dk);
!     
! 	/* If controller not already active, start it. */
! 	if (!active)
! 		wdcstart(wdc);
! }
! 
! /*
!  * Finish an I/O operation.  Clean up the drive and controller state, set the
!  * residual count, and inform the upper layers that the operation is complete.
!  */
! void
! wdfinish(wd, bp)
! 	struct wd_softc *wd;
! 	struct buf *bp;
! {
! 	struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
! 
! 	wdc->sc_flags &= ~(WDCF_SINGLE | WDCF_ERROR);
! 	wdc->sc_errors = 0;
! 	/*
! 	 * Move this drive to the end of the queue to give others a `fair'
! 	 * chance.
! 	 */
! 	if (wd->sc_drivechain.tqe_next) {
! 		TAILQ_REMOVE(&wdc->sc_drives, wd, sc_drivechain);
! 		if (bp->b_actf) {
! 			TAILQ_INSERT_TAIL(&wdc->sc_drives, wd, sc_drivechain);
! 		} else
! 			wd->sc_q.b_active = 0;
! 	}
! 	bp->b_resid = wd->sc_bcount;
! 	wd->sc_skip = 0;
! 	wd->sc_q.b_actf = bp->b_actf;
! 
! 	disk_unbusy(&wd->sc_dk, (bp->b_bcount - bp->b_resid));
  
! 	if (!wd->sc_q.b_actf) {
! 		TAILQ_REMOVE(&wdc->sc_drives, wd, sc_drivechain);
! 		wd->sc_q.b_active = 0;
! 	} else
  		disk_busy(&wd->sc_dk);
! 
! 	biodone(bp);
  }
  
  int
--- 256,297 ----
  wdstart(wd)
  	struct wd_softc *wd;
  {
! 	struct buf *dp, *bp=0;
! 	struct wd_link *d_link = wd->d_link;
! 	struct wdc_link *ctlr_link = d_link->ctlr_link;
! 	struct wdc_xfer *xfer;
! /*	int blkno, nblks;*/
! 	u_long p_offset; 
! 
! 	while (d_link->openings > 0) {
! 
! 		/* Is there a buf for us ? */
! 		dp = &wd->sc_q;
! 		if ((bp = dp->b_actf) == NULL)  /* yes, an assign */
!                  	return;
! 		dp->b_actf = bp->b_actf;
! 		
! 		/* 
!          * Make the command. First lock the device
! 		 */
! 		d_link->openings--;
! 		if (WDPART(bp->b_dev) != RAW_PART)
! 			p_offset=wd->sc_dk.dk_label->d_partitions[WDPART(bp->b_dev)].p_offset;
! 		else p_offset=0;
! 		xfer = wdc_get_xfer(ctlr_link,0);
! 		if (xfer == NULL) panic("wdc_xfer");
! 		xfer->d_link = d_link;
! 		xfer->c_bp = bp;
! 		xfer->c_p_offset = p_offset;
! 		xfer->databuf = bp->b_data;
! 		xfer->c_bcount = bp->b_bcount;
! 		xfer->c_flags |= bp->b_flags & (B_READ|B_WRITE);
! 		xfer->c_blkno = bp->b_blkno;
  
! 		/* Instrumentation. */
  		disk_busy(&wd->sc_dk);
! 		wdc_exec_xfer(wd->d_link,xfer);
! 	}
  }
  
  int
***************
*** 500,506 ****
  	struct uio *uio;
  	int flags;
  {
! 
  	return (physio(wdstrategy, NULL, dev, B_READ, minphys, uio));
  }
  
--- 300,308 ----
  	struct uio *uio;
  	int flags;
  {
! #ifdef WDDEBUG
! 	printf("wdread\n");
! #endif
  	return (physio(wdstrategy, NULL, dev, B_READ, minphys, uio));
  }
  
***************
*** 510,884 ****
  	struct uio *uio;
  	int flags;
  {
- 
- 	return (physio(wdstrategy, NULL, dev, B_WRITE, minphys, uio));
- }
- 
- /*
-  * Start I/O on a controller.  This does the calculation, and starts a read or
-  * write operation.  Called to from wdstart() to start a transfer, from
-  * wdcintr() to continue a multi-sector transfer or start the next transfer, or
-  * wdcrestart() after recovering from an error.
-  */
- void
- wdcstart(wdc)
- 	struct wdc_softc *wdc;
- {
- 	struct wd_softc *wd;
- 	struct buf *bp;
- 	struct disklabel *lp;
- 	int nblks;
- 
- #ifdef DIAGNOSTIC
- 	if ((wdc->sc_flags & WDCF_ACTIVE) != 0)
- 		panic("wdcstart: controller still active");
- #endif
- 
- 	/*
- 	 * XXX
- 	 * This is a kluge.  See comments in wd_get_parms().
- 	 */
- 	if ((wdc->sc_flags & WDCF_WANTED) != 0) {
- 		wdc->sc_flags &= ~WDCF_WANTED;
- 		wakeup(wdc);
- 		return;
- 	}
- 
- loop:
- 	/* Is there a drive for the controller to do a transfer with? */
- 	wd = wdc->sc_drives.tqh_first;
- 	if (wd == NULL)
- 		return;
-     
- 	/* Is there a transfer to this drive?  If not, deactivate drive. */
- 	bp = wd->sc_q.b_actf;
-     
- 	if (wdc->sc_errors >= WDIORETRIES) {
- 		wderror(wd, bp, "hard error");
- 		bp->b_error = EIO;
- 		bp->b_flags |= B_ERROR;
- 		wdfinish(wd, bp);
- 		goto loop;
- 	}
- 
- 	/* Do control operations specially. */
- 	if (wd->sc_state < OPEN) {
- 		/*
- 		 * Actually, we want to be careful not to mess with the control
- 		 * state if the device is currently busy, but we can assume
- 		 * that we never get to this point if that's the case.
- 		 */
- 		if (wdcontrol(wd) == 0) {
- 			/* The drive is busy.  Wait. */
- 			return;
- 		}
- 	}
- 
- 	/*
- 	 * WDCF_ERROR is set by wdcunwedge() and wdcintr() when an error is
- 	 * encountered.  If we are in multi-sector mode, then we switch to
- 	 * single-sector mode and retry the operation from the start.
- 	 */
- 	if (wdc->sc_flags & WDCF_ERROR) {
- 		wdc->sc_flags &= ~WDCF_ERROR;
- 		if ((wdc->sc_flags & WDCF_SINGLE) == 0) {
- 			wdc->sc_flags |= WDCF_SINGLE;
- 			wd->sc_skip = 0;
- 		}
- 	}
- 
- 	lp = wd->sc_dk.dk_label;
- 
- 	/* When starting a transfer... */
- 	if (wd->sc_skip == 0) {
- 		int part = WDPART(bp->b_dev);
- 		daddr_t blkno;
- 
- #ifdef WDDEBUG
- 		printf("\n%s: wdcstart %s %d@%d; map ", wd->sc_dev.dv_xname,
- 		    (bp->b_flags & B_READ) ? "read" : "write", bp->b_bcount,
- 		    bp->b_blkno);
- #endif
- 		wd->sc_bcount = bp->b_bcount;
- 		blkno = bp->b_blkno;
- 		if (part != RAW_PART)
- 			blkno += lp->d_partitions[part].p_offset;
- 		wd->sc_blkno = blkno / (lp->d_secsize / DEV_BSIZE);
- 	} else {
- #ifdef WDDEBUG
- 		printf(" %d)%x", wd->sc_skip, inb(wd->sc_iobase+wd_altsts));
- #endif
- 	}
- 
- 	/* When starting a multi-sector transfer, or doing single-sector
- 	    transfers... */
- 	if (wd->sc_skip == 0 || (wdc->sc_flags & WDCF_SINGLE) != 0 ||
- 	    wd->sc_mode == WDM_DMA) {
- 		daddr_t blkno = wd->sc_blkno;
- 		long cylin, head, sector;
- 		int command;
- 
- 		if ((wdc->sc_flags & WDCF_SINGLE) != 0)
- 			nblks = 1;
- 		else if (wd->sc_mode != WDM_DMA)
- 			nblks = wd->sc_bcount / lp->d_secsize;
- 		else
- 			nblks = min(wd->sc_bcount / lp->d_secsize, 8);
- 
- 		/* Check for bad sectors and adjust transfer, if necessary. */
- 		if ((lp->d_flags & D_BADSECT) != 0
- #ifdef B_FORMAT
- 		    && (bp->b_flags & B_FORMAT) == 0
- #endif
- 		    ) {
- 			long blkdiff;
- 			int i;
- 
- 			for (i = 0; (blkdiff = wd->sc_badsect[i]) != -1; i++) {
- 				blkdiff -= blkno;
- 				if (blkdiff < 0)
- 					continue;
- 				if (blkdiff == 0) {
- 					/* Replace current block of transfer. */
- 					blkno =
- 					    lp->d_secperunit - lp->d_nsectors - i - 1;
- 				}
- 				if (blkdiff < nblks) {
- 					/* Bad block inside transfer. */
- 					wdc->sc_flags |= WDCF_SINGLE;
- 					nblks = 1;
- 				}
- 				break;
- 			}
- 			/* Tranfer is okay now. */
- 		}
- 
- 		if ((wd->sc_params.wdp_capabilities & WD_CAP_LBA) != 0) {
- 			sector = (blkno >> 0) & 0xff;
- 			cylin = (blkno >> 8) & 0xffff;
- 			head = (blkno >> 24) & 0xf;
- 			head |= WDSD_LBA;
- 		} else {
- 			sector = blkno % lp->d_nsectors;
- 			sector++;	/* Sectors begin with 1, not 0. */
- 			blkno /= lp->d_nsectors;
- 			head = blkno % lp->d_ntracks;
- 			blkno /= lp->d_ntracks;
- 			cylin = blkno;
- 			head |= WDSD_CHS;
- 		}
- 
- 		if (wd->sc_mode == WDM_PIOSINGLE ||
- 		    (wdc->sc_flags & WDCF_SINGLE) != 0)
- 			wd->sc_nblks = 1;
- 		else if (wd->sc_mode == WDM_PIOMULTI)
- 			wd->sc_nblks = min(nblks, wd->sc_multiple);
- 		else
- 			wd->sc_nblks = nblks;
- 		wd->sc_nbytes = wd->sc_nblks * lp->d_secsize;
-     
- #ifdef B_FORMAT
- 		if (bp->b_flags & B_FORMAT) {
- 			sector = lp->d_gap3;
- 			nblks = lp->d_nsectors;
- 			command = WDCC_FORMAT;
- 		} else
- #endif
- 		switch (wd->sc_mode) {
- 		case WDM_DMA:
- #if 0
- 			command = (bp->b_flags & B_READ) ?
- 			    WDCC_READDMA : WDCC_WRITEDMA;
- 			/* Start the DMA channel and bounce the buffer if
- 			   necessary. */
- 			isa_dmastart(
- 			    bp->b_flags & B_READ ? DMAMODE_READ : DMAMODE_WRITE,
- 			    bp->b_data + wd->sc_skip,
- 			    wd->sc_nbytes, wdc->sc_drq);
- #endif
- 			panic("wd cannot do DMA yet\n");
- 			break;
- 		case WDM_PIOMULTI:
- 			command = (bp->b_flags & B_READ) ?
- 			    WDCC_READMULTI : WDCC_WRITEMULTI;
- 			break;
- 		case WDM_PIOSINGLE:
- 			command = (bp->b_flags & B_READ) ?
- 			    WDCC_READ : WDCC_WRITE;
- 			break;
- 		default:
- #ifdef DIAGNOSTIC
- 			panic("bad wd mode");
- #endif
- 			return;
- 		}
- 	
- 		/* Initiate command! */
- 		if (wdcommand(wd, command, cylin, head, sector, nblks) != 0) {
- 			wderror(wd, NULL,
- 			    "wdcstart: timeout waiting for unbusy");
- 			wdcunwedge(wdc);
- 			return;
- 		}
- 
  #ifdef WDDEBUG
! 		printf("sector %d cylin %d head %d addr %x sts %x\n", sector,
! 		    cylin, head, bp->b_data, 0/*inb(wd->sc_iobase+wd_altsts*/));
! #endif
! 	} else if (wd->sc_nblks > 1) {
! 		/* The number of blocks in the last stretch may be smaller. */
! 		nblks = wd->sc_bcount / lp->d_secsize;
! 		if (wd->sc_nblks > nblks) {
! 			wd->sc_nblks = nblks;
! 			wd->sc_nbytes = wd->sc_bcount;
! 		}
! 	}
! 
! 	/* If this was a write and not using DMA, push the data. */
! 	if (wd->sc_mode != WDM_DMA &&
! 	    (bp->b_flags & (B_READ|B_WRITE)) == B_WRITE) {
! 		if (wait_for_drq(wdc) < 0) {
! 			wderror(wd, NULL, "wdcstart: timeout waiting for drq");
! 			wdcunwedge(wdc);
! 			return;
! 		}
! 
! 		/* Push out data. */
! 		if ((wd->sc_flags & WDF_32BIT) == 0)
! 			outsw(wdc->sc_iobase+wd_data, bp->b_data + wd->sc_skip,
! 			    wd->sc_nbytes >> 1);
! 		else
! 			outsl(wdc->sc_iobase+wd_data, bp->b_data + wd->sc_skip,
! 			    wd->sc_nbytes >> 2);
! 	}
! 
! 	wdc->sc_flags |= WDCF_ACTIVE;
! 	timeout(wdctimeout, wdc, WAITTIME);
! }
! 
! /*
!  * Interrupt routine for the controller.  Acknowledge the interrupt, check for
!  * errors on the current operation, mark it done if necessary, and start the
!  * next request.  Also check for a partially done transfer, and continue with
!  * the next chunk if so.
!  */
! int
! wdcintr(arg)
! 	void *arg;
! {
! 	struct wdc_softc *wdc = arg;
! 	struct wd_softc *wd;
! 	struct buf *bp;
! 
! 	if ((wdc->sc_flags & WDCF_ACTIVE) == 0) {
! 		/* Clear the pending interrupt and abort. */
! 		(void) inb(wdc->sc_iobase+wd_status);
! 		return 0;
! 	}
! 
! 	wdc->sc_flags &= ~WDCF_ACTIVE;
! 	untimeout(wdctimeout, wdc);
! 
! 	wd = wdc->sc_drives.tqh_first;
! 	bp = wd->sc_q.b_actf;
! 
! #ifdef WDDEBUG
! 	printf("I%d ", ctrlr);
! #endif
! 
! 	if (wait_for_unbusy(wdc) < 0) {
! 		wderror(wd, NULL, "wdcintr: timeout waiting for unbusy");
! 		wdc->sc_status |= WDCS_ERR;	/* XXX */
! 	}
!     
! 	/* Is it not a transfer, but a control operation? */
! 	if (wd->sc_state < OPEN) {
! 		if (wdcontrol(wd) == 0) {
! 			/* The drive is busy.  Wait. */
! 			return 1;
! 		}
! 		wdcstart(wdc);
! 		return 1;
! 	}
! 
! 	/* Turn off the DMA channel and unbounce the buffer. */
! 	if (wd->sc_mode == WDM_DMA)
! 		panic("wd cannot do DMA\n");
! #if 0
! 		isa_dmadone(bp->b_flags & B_READ ? DMAMODE_READ : DMAMODE_WRITE,
! 		    bp->b_data + wd->sc_skip, wd->sc_nbytes, wdc->sc_drq);
! #endif
! 	/* Have we an error? */
! 	if (wdc->sc_status & WDCS_ERR) {
! #ifdef WDDEBUG
! 		wderror(wd, NULL, "wdcintr");
! #endif
! 		if ((wdc->sc_flags & WDCF_SINGLE) == 0) {
! 			wdc->sc_flags |= WDCF_ERROR;
! 			goto restart;
! 		}
! 
! #ifdef B_FORMAT
! 		if (bp->b_flags & B_FORMAT)
! 			goto bad;
! #endif
! 	
! 		if (++wdc->sc_errors < WDIORETRIES)
! 			goto restart;
! 		wderror(wd, bp, "hard error");
! 
! #ifdef B_FORMAT
! 	bad:
  #endif
- 		bp->b_error = EIO;
- 		bp->b_flags |= B_ERROR;
- 		goto done;
- 	}
- 
- 	/* If this was a read and not using DMA, fetch the data. */
- 	if (wd->sc_mode != WDM_DMA &&
- 	    (bp->b_flags & (B_READ|B_WRITE)) == B_READ) {
- 		if ((wdc->sc_status & (WDCS_DRDY | WDCS_DSC | WDCS_DRQ))
- 		    != (WDCS_DRDY | WDCS_DSC | WDCS_DRQ)) {
- 			wderror(wd, NULL, "wdcintr: read intr before drq");
- 			wdcunwedge(wdc);
- 			return 1;
- 		}
- 
- 		/* Pull in data. */
- 		if ((wd->sc_flags & WDF_32BIT) == 0)
- 			insw(wdc->sc_iobase+wd_data, bp->b_data + wd->sc_skip, 
- 			    wd->sc_nbytes >> 1);
- 		else
- 			insl(wdc->sc_iobase+wd_data, bp->b_data + wd->sc_skip, 
- 			    wd->sc_nbytes >> 2);
- 	}
-     
- 	/* If we encountered any abnormalities, flag it as a soft error. */
- 	if (wdc->sc_errors > 0 ||
- 	    (wdc->sc_status & WDCS_CORR) != 0) {
- 		wderror(wd, bp, "soft error (corrected)");
- 		wdc->sc_errors = 0;
- 	}
-     
- 	/* Adjust pointers for the next block, if any. */
- 	wd->sc_blkno += wd->sc_nblks;
- 	wd->sc_skip += wd->sc_nbytes;
- 	wd->sc_bcount -= wd->sc_nbytes;
- 
- 	/* See if this transfer is complete. */
- 	if (wd->sc_bcount > 0)
- 		goto restart;
- 
- done:
- 	/* Done with this transfer, with or without error. */
- 	wdfinish(wd, bp);
- 
- restart:
- 	/* Start the next operation, if any. */
- 	wdcstart(wdc);
  
! 	return 1;
  }
  
  /*
--- 312,322 ----
  	struct uio *uio;
  	int flags;
  {
  #ifdef WDDEBUG
!     printf("wdwrite\n");
  #endif
  
! 	return (physio(wdstrategy, NULL, dev, B_WRITE, minphys, uio));
  }
  
  /*
***************
*** 888,904 ****
   * Several drivers do this; it should be abstracted and made MP-safe.
   */
  int
! wdlock(wd)
! 	struct wd_softc *wd;
  {
  	int error;
  
! 	while ((wd->sc_flags & WDF_LOCKED) != 0) {
! 		wd->sc_flags |= WDF_WANTED;
! 		if ((error = tsleep(wd, PRIBIO | PCATCH, "wdlck", 0)) != 0)
  			return error;
  	}
! 	wd->sc_flags |= WDF_LOCKED;
  	return 0;
  }
  
--- 326,351 ----
   * Several drivers do this; it should be abstracted and made MP-safe.
   */
  int
! wdlock(d_link)
! 	struct wd_link *d_link;
  {
  	int error;
+ 	int s;
  
! #ifdef WDDEBUG
! 	printf("wdlock\n");
! #endif
! 	s=splbio();
! 
! 	while ((d_link->sc_flags & WDF_LOCKED) != 0) {
! 		d_link->sc_flags |= WDF_WANTED;
! 		if ((error = tsleep(d_link, PRIBIO | PCATCH, "wdlck", 0)) != 0) {
! 			splx(s);
  			return error;
+ 		}
  	}
! 	d_link->sc_flags |= WDF_LOCKED;
! 	splx(s);
  	return 0;
  }
  
***************
*** 906,919 ****
   * Unlock and wake up any waiters.
   */
  void
! wdunlock(wd)
! 	struct wd_softc *wd;
  {
  
! 	wd->sc_flags &= ~WDF_LOCKED;
! 	if ((wd->sc_flags & WDF_WANTED) != 0) {
! 		wd->sc_flags &= ~WDF_WANTED;
! 		wakeup(wd);
  	}
  }
  
--- 353,369 ----
   * Unlock and wake up any waiters.
   */
  void
! wdunlock(d_link)
! 	struct wd_link *d_link;
  {
+ #ifdef WDDEBUG
+     printf("wdunlock\n");
+ #endif
  
! 	d_link->sc_flags &= ~WDF_LOCKED;
! 	if ((d_link->sc_flags & WDF_WANTED) != 0) {
! 		d_link->sc_flags &= ~WDF_WANTED;
! 		wakeup(d_link);
  	}
  }
  
***************
*** 924,931 ****
--- 374,387 ----
  	struct proc *p;
  {
  	struct wd_softc *wd;
+ 	struct wd_link *d_link;
  	int unit, part;
  	int error;
+ 
+ #ifdef WDDEBUG
+     printf("wdopen\n");
+ #endif
+ 
      
  	unit = WDUNIT(dev);
  	if (unit >= wd_cd.cd_ndevs)
***************
*** 934,957 ****
  	if (wd == 0)
  		return ENXIO;
      
! 	if ((error = wdlock(wd)) != 0)
  		return error;
- 
  	if (wd->sc_dk.dk_openmask != 0) {
  		/*
  		 * If any partition is open, but the disk has been invalidated,
  		 * disallow further opens.
  		 */
! 		if ((wd->sc_flags & WDF_LOADED) == 0) {
  			error = EIO;
  			goto bad3;
  		}
  	} else {
! 		if ((wd->sc_flags & WDF_LOADED) == 0) {
! 			wd->sc_flags |= WDF_LOADED;
  
  			/* Load the physical device parameters. */
! 			if (wd_get_parms(wd) != 0) {
  				error = ENXIO;
  				goto bad2;
  			}
--- 390,413 ----
  	if (wd == 0)
  		return ENXIO;
      
! 	d_link = wd->d_link;
! 	if ((error = wdlock(d_link)) != 0)
  		return error;
  	if (wd->sc_dk.dk_openmask != 0) {
  		/*
  		 * If any partition is open, but the disk has been invalidated,
  		 * disallow further opens.
  		 */
! 		if ((d_link->sc_flags & WDF_LOADED) == 0) {
  			error = EIO;
  			goto bad3;
  		}
  	} else {
! 		if ((d_link->sc_flags & WDF_LOADED) == 0) {
! 			d_link->sc_flags |= WDF_LOADED;
  
  			/* Load the physical device parameters. */
! 			if (wdc_get_parms(d_link) != 0) {
  				error = ENXIO;
  				goto bad2;
  			}
***************
*** 982,999 ****
  	}
  	wd->sc_dk.dk_openmask = wd->sc_dk.dk_copenmask | wd->sc_dk.dk_bopenmask;
  
! 	wdunlock(wd);
  	return 0;
  
  bad2:
! 	wd->sc_flags &= ~WDF_LOADED;
  
  bad:
  	if (wd->sc_dk.dk_openmask == 0) {
  	}
  
  bad3:
! 	wdunlock(wd);
  	return error;
  }
  
--- 438,455 ----
  	}
  	wd->sc_dk.dk_openmask = wd->sc_dk.dk_copenmask | wd->sc_dk.dk_bopenmask;
  
! 	wdunlock(d_link);
  	return 0;
  
  bad2:
! 	d_link->sc_flags &= ~WDF_LOADED;
  
  bad:
  	if (wd->sc_dk.dk_openmask == 0) {
  	}
  
  bad3:
! 	wdunlock(d_link);
  	return error;
  }
  
***************
*** 1007,1013 ****
  	int part = WDPART(dev);
  	int error;
      
! 	if ((error = wdlock(wd)) != 0)
  		return error;
  
  	switch (fmt) {
--- 463,469 ----
  	int part = WDPART(dev);
  	int error;
      
! 	if ((error = wdlock(wd->d_link)) != 0)
  		return error;
  
  	switch (fmt) {
***************
*** 1024,1030 ****
  		/* XXXX Must wait for I/O to complete! */
  	}
  
! 	wdunlock(wd);
  	return 0;
  }
  
--- 480,486 ----
  		/* XXXX Must wait for I/O to complete! */
  	}
  
! 	wdunlock(wd->d_link);
  	return 0;
  }
  
